#ifndef PARSER_H
#define PARSER_H

#ifdef _WIN32
#include <windows.h>
#endif

typedef struct _USSDCallbacks{
	void (*ussdService)(int dialogId,char* shortCode,char* phoneNumber);
	void (*ussdResponse)(int dialogId,char* str);
	void (*ussdEnd)(int dialogId);
	void (*disconnected)();
	void (*connected)();
	void (*ping)();
} USSDCallbacks;

/*
	Programador: Alejandro Leib
*/
typedef int (*pongFn)();
typedef int (*ussd_endFn)(int dialogId, char* text);
typedef int (*ussd_requestFn)(int dialogId,char* prompt);
typedef int (*ussd_requestShortCodeFn)(char* shortCode);
typedef int (*ussd_initiateFn)(int dialogId,char* phoneNumber,char* prompt);
typedef int (*connectgwFn)(char* addr, int port, int jrx, int jtx);
typedef int (*initializeFn)(USSDCallbacks* callbacks);

class CUSSD
{
public:
	CUSSD();
	~CUSSD();

	int pong();
	int ussd_end(int dialogId, char* text);
	int ussd_request(int dialogId,char* prompt);
	int ussd_initiate(int dialogId,char* phoneNumber,char* prompt);
	int ussd_requestShortCode(char* shortCode);
 	int connectgw(char* addr, int port, int jrx, int jtx);
	int initialize(USSDCallbacks* callbacks);

private:
	pongFn 					dll_pong;
	ussd_endFn				dll_ussd_end;
	ussd_requestFn			dll_ussd_request;
	ussd_initiateFn			dll_ussd_initiate;
	connectgwFn				dll_connectgw;
	initializeFn			dll_initialize;
	ussd_requestShortCodeFn	dll_ussd_requestShortCode;

#ifdef _WIN32
	HINSTANCE ussdDll;
#else
	void*     ussdDll;
#endif
};

#endif // PARSER_H
